// Copyright 1986-2019 Xilinx, Inc. All Rights Reserved.
// --------------------------------------------------------------------------------
// Tool Version: Vivado v.2019.2 (win64) Build 2708876 Wed Nov  6 21:40:23 MST 2019
// Date        : Mon Feb 10 16:17:25 2020
// Host        : DESKTOP-C2BNKT2 running 64-bit major release  (build 9200)
// Command     : write_verilog -force -mode funcsim
//               D:/imperix_sandbox_sources/projects/sb_project_2019.2/sb_project.srcs/sources_1/bd/top/ip/top_DirectCurrentControl_0_4/top_DirectCurrentControl_0_4_sim_netlist.v
// Design      : top_DirectCurrentControl_0_4
// Purpose     : This verilog netlist is a functional simulation representation of the design and should not be modified
//               or synthesized. This netlist cannot be used for SDF annotated simulation.
// Device      : xc7z030fbg676-3
// --------------------------------------------------------------------------------
`timescale 1 ps / 1 ps

(* CHECK_LICENSE_TYPE = "top_DirectCurrentControl_0_4,DirectCurrentControl,{}" *) (* downgradeipidentifiedwarnings = "yes" *) (* ip_definition_source = "module_ref" *) 
(* x_core_info = "DirectCurrentControl,Vivado 2019.2" *) 
(* NotValidForBitStream *)
module top_DirectCurrentControl_0_4
   (meas_in,
    ref_in,
    tol_in,
    delay_in,
    err_out,
    adc_done_pulse_in,
    data_valid_pulse_in,
    pwm_out,
    clk_in);
  input [15:0]meas_in;
  input [15:0]ref_in;
  input [15:0]tol_in;
  input [15:0]delay_in;
  output [15:0]err_out;
  input adc_done_pulse_in;
  input data_valid_pulse_in;
  output pwm_out;
  (* x_interface_info = "xilinx.com:signal:clock:1.0 clk CLK" *) (* x_interface_parameter = "XIL_INTERFACENAME clk, FREQ_HZ 250000000, PHASE 0, CLK_DOMAIN top_IXIP_0_0_clk_250_mhz, INSERT_VIP 0" *) input clk_in;

  wire adc_done_pulse_in;
  wire clk_in;
  wire data_valid_pulse_in;
  wire [15:0]delay_in;
  wire [15:0]err_out;
  wire [15:0]meas_in;
  wire pwm_out;
  wire [15:0]ref_in;
  wire [15:0]tol_in;

  top_DirectCurrentControl_0_4_DirectCurrentControl U0
       (.adc_done_pulse_in(adc_done_pulse_in),
        .clk_in(clk_in),
        .data_valid_pulse_in(data_valid_pulse_in),
        .delay_in(delay_in),
        .err_out(err_out),
        .meas_in(meas_in),
        .pwm_out(pwm_out),
        .ref_in(ref_in),
        .tol_in(tol_in));
endmodule

(* ORIG_REF_NAME = "DirectCurrentControl" *) 
module top_DirectCurrentControl_0_4_DirectCurrentControl
   (pwm_out,
    err_out,
    clk_in,
    data_valid_pulse_in,
    ref_in,
    adc_done_pulse_in,
    meas_in,
    tol_in,
    delay_in);
  output pwm_out;
  output [15:0]err_out;
  input clk_in;
  input data_valid_pulse_in;
  input [15:0]ref_in;
  input adc_done_pulse_in;
  input [15:0]meas_in;
  input [15:0]tol_in;
  input [15:0]delay_in;

  wire \FSM_sequential_fsm_state[0]_i_1_n_0 ;
  wire \FSM_sequential_fsm_state[1]_i_1_n_0 ;
  wire adc_done_pulse_in;
  wire clk_in;
  wire \counter_reg[0]_i_1_n_0 ;
  wire \counter_reg[15]_i_1_n_0 ;
  wire \counter_reg_reg[12]_i_1_n_0 ;
  wire \counter_reg_reg[12]_i_1_n_1 ;
  wire \counter_reg_reg[12]_i_1_n_2 ;
  wire \counter_reg_reg[12]_i_1_n_3 ;
  wire \counter_reg_reg[15]_i_2_n_2 ;
  wire \counter_reg_reg[15]_i_2_n_3 ;
  wire \counter_reg_reg[4]_i_1_n_0 ;
  wire \counter_reg_reg[4]_i_1_n_1 ;
  wire \counter_reg_reg[4]_i_1_n_2 ;
  wire \counter_reg_reg[4]_i_1_n_3 ;
  wire \counter_reg_reg[8]_i_1_n_0 ;
  wire \counter_reg_reg[8]_i_1_n_1 ;
  wire \counter_reg_reg[8]_i_1_n_2 ;
  wire \counter_reg_reg[8]_i_1_n_3 ;
  wire \counter_reg_reg_n_0_[0] ;
  wire \counter_reg_reg_n_0_[10] ;
  wire \counter_reg_reg_n_0_[11] ;
  wire \counter_reg_reg_n_0_[12] ;
  wire \counter_reg_reg_n_0_[13] ;
  wire \counter_reg_reg_n_0_[14] ;
  wire \counter_reg_reg_n_0_[15] ;
  wire \counter_reg_reg_n_0_[1] ;
  wire \counter_reg_reg_n_0_[2] ;
  wire \counter_reg_reg_n_0_[3] ;
  wire \counter_reg_reg_n_0_[4] ;
  wire \counter_reg_reg_n_0_[5] ;
  wire \counter_reg_reg_n_0_[6] ;
  wire \counter_reg_reg_n_0_[7] ;
  wire \counter_reg_reg_n_0_[8] ;
  wire \counter_reg_reg_n_0_[9] ;
  wire data_valid_pulse_in;
  wire [15:0]delay_in;
  wire err_carry__0_i_1_n_0;
  wire err_carry__0_i_2_n_0;
  wire err_carry__0_i_3_n_0;
  wire err_carry__0_i_4_n_0;
  wire err_carry__0_n_0;
  wire err_carry__0_n_1;
  wire err_carry__0_n_2;
  wire err_carry__0_n_3;
  wire err_carry__1_i_1_n_0;
  wire err_carry__1_i_2_n_0;
  wire err_carry__1_i_3_n_0;
  wire err_carry__1_i_4_n_0;
  wire err_carry__1_n_0;
  wire err_carry__1_n_1;
  wire err_carry__1_n_2;
  wire err_carry__1_n_3;
  wire err_carry__2_i_1_n_0;
  wire err_carry__2_i_2_n_0;
  wire err_carry__2_i_3_n_0;
  wire err_carry__2_i_4_n_0;
  wire err_carry__2_n_1;
  wire err_carry__2_n_2;
  wire err_carry__2_n_3;
  wire err_carry_i_1_n_0;
  wire err_carry_i_2_n_0;
  wire err_carry_i_3_n_0;
  wire err_carry_i_4_n_0;
  wire err_carry_n_0;
  wire err_carry_n_1;
  wire err_carry_n_2;
  wire err_carry_n_3;
  wire [15:0]err_out;
  wire [1:0]fsm_state;
  wire fsm_state0__15_carry__0_n_1;
  wire fsm_state0__15_carry__0_n_2;
  wire fsm_state0__15_carry__0_n_3;
  wire fsm_state0__15_carry_i_1__0_n_0;
  wire fsm_state0__15_carry_i_1_n_0;
  wire fsm_state0__15_carry_i_2__0_n_0;
  wire fsm_state0__15_carry_i_2_n_0;
  wire fsm_state0__15_carry_i_3__0_n_0;
  wire fsm_state0__15_carry_i_3_n_0;
  wire fsm_state0__15_carry_i_4__0_n_0;
  wire fsm_state0__15_carry_i_4_n_0;
  wire fsm_state0__15_carry_i_5__0_n_0;
  wire fsm_state0__15_carry_i_5_n_0;
  wire fsm_state0__15_carry_i_6__0_n_0;
  wire fsm_state0__15_carry_i_6_n_0;
  wire fsm_state0__15_carry_i_7__0_n_0;
  wire fsm_state0__15_carry_i_7_n_0;
  wire fsm_state0__15_carry_i_8__0_n_0;
  wire fsm_state0__15_carry_i_8_n_0;
  wire fsm_state0__15_carry_n_0;
  wire fsm_state0__15_carry_n_1;
  wire fsm_state0__15_carry_n_2;
  wire fsm_state0__15_carry_n_3;
  wire fsm_state0__7_carry__0_i_1_n_0;
  wire fsm_state0__7_carry__0_i_2_n_0;
  wire fsm_state0__7_carry__0_i_3_n_0;
  wire fsm_state0__7_carry__0_i_4_n_0;
  wire fsm_state0__7_carry__0_i_5_n_0;
  wire fsm_state0__7_carry__0_i_6_n_0;
  wire fsm_state0__7_carry__0_i_7_n_0;
  wire fsm_state0__7_carry__0_i_8_n_0;
  wire fsm_state0__7_carry__0_n_0;
  wire fsm_state0__7_carry__0_n_1;
  wire fsm_state0__7_carry__0_n_2;
  wire fsm_state0__7_carry__0_n_3;
  wire fsm_state0__7_carry_i_1_n_0;
  wire fsm_state0__7_carry_i_2_n_0;
  wire fsm_state0__7_carry_i_3_n_0;
  wire fsm_state0__7_carry_i_4_n_0;
  wire fsm_state0__7_carry_i_5_n_0;
  wire fsm_state0__7_carry_i_6_n_0;
  wire fsm_state0__7_carry_i_7_n_0;
  wire fsm_state0__7_carry_i_8_n_0;
  wire fsm_state0__7_carry_n_0;
  wire fsm_state0__7_carry_n_1;
  wire fsm_state0__7_carry_n_2;
  wire fsm_state0__7_carry_n_3;
  wire fsm_state0_carry__0_i_1_n_0;
  wire fsm_state0_carry__0_i_2_n_0;
  wire fsm_state0_carry__0_i_3_n_0;
  wire fsm_state0_carry__0_i_4_n_0;
  wire fsm_state0_carry__0_i_5_n_0;
  wire fsm_state0_carry__0_i_6_n_0;
  wire fsm_state0_carry__0_i_7_n_0;
  wire fsm_state0_carry__0_i_8_n_0;
  wire fsm_state0_carry__0_n_0;
  wire fsm_state0_carry__0_n_1;
  wire fsm_state0_carry__0_n_2;
  wire fsm_state0_carry__0_n_3;
  wire fsm_state0_carry_i_1_n_0;
  wire fsm_state0_carry_i_2_n_0;
  wire fsm_state0_carry_i_3_n_0;
  wire fsm_state0_carry_i_4_n_0;
  wire fsm_state0_carry_i_5_n_0;
  wire fsm_state0_carry_i_6_n_0;
  wire fsm_state0_carry_i_7_n_0;
  wire fsm_state0_carry_i_8_n_0;
  wire fsm_state0_carry_n_0;
  wire fsm_state0_carry_n_1;
  wire fsm_state0_carry_n_2;
  wire fsm_state0_carry_n_3;
  wire [15:0]fsm_state1;
  wire fsm_state1_carry__0_i_1_n_0;
  wire fsm_state1_carry__0_i_2_n_0;
  wire fsm_state1_carry__0_i_3_n_0;
  wire fsm_state1_carry__0_i_4_n_0;
  wire fsm_state1_carry__0_n_0;
  wire fsm_state1_carry__0_n_1;
  wire fsm_state1_carry__0_n_2;
  wire fsm_state1_carry__0_n_3;
  wire fsm_state1_carry__1_i_1_n_0;
  wire fsm_state1_carry__1_i_2_n_0;
  wire fsm_state1_carry__1_i_3_n_0;
  wire fsm_state1_carry__1_i_4_n_0;
  wire fsm_state1_carry__1_n_0;
  wire fsm_state1_carry__1_n_1;
  wire fsm_state1_carry__1_n_2;
  wire fsm_state1_carry__1_n_3;
  wire fsm_state1_carry__2_i_1_n_0;
  wire fsm_state1_carry__2_i_2_n_0;
  wire fsm_state1_carry__2_i_3_n_0;
  wire fsm_state1_carry__2_i_4_n_0;
  wire fsm_state1_carry__2_n_1;
  wire fsm_state1_carry__2_n_2;
  wire fsm_state1_carry__2_n_3;
  wire fsm_state1_carry_i_1_n_0;
  wire fsm_state1_carry_i_2_n_0;
  wire fsm_state1_carry_i_3_n_0;
  wire fsm_state1_carry_n_0;
  wire fsm_state1_carry_n_1;
  wire fsm_state1_carry_n_2;
  wire fsm_state1_carry_n_3;
  wire [15:1]in4;
  wire [15:0]meas_ff1;
  wire [15:0]meas_in;
  wire p_0_in;
  wire pwm_out;
  wire pwm_out_i_1_n_0;
  wire [15:0]ref_ff1;
  wire [15:0]ref_ff2;
  wire [15:0]ref_in;
  wire [15:0]tol_ff1;
  wire [15:0]tol_ff2;
  wire [15:0]tol_in;
  wire [3:2]\NLW_counter_reg_reg[15]_i_2_CO_UNCONNECTED ;
  wire [3:3]\NLW_counter_reg_reg[15]_i_2_O_UNCONNECTED ;
  wire [3:3]NLW_err_carry__2_CO_UNCONNECTED;
  wire [3:0]NLW_fsm_state0__15_carry_O_UNCONNECTED;
  wire [3:0]NLW_fsm_state0__15_carry__0_O_UNCONNECTED;
  wire [3:0]NLW_fsm_state0__7_carry_O_UNCONNECTED;
  wire [3:0]NLW_fsm_state0__7_carry__0_O_UNCONNECTED;
  wire [3:0]NLW_fsm_state0_carry_O_UNCONNECTED;
  wire [3:0]NLW_fsm_state0_carry__0_O_UNCONNECTED;
  wire [3:3]NLW_fsm_state1_carry__2_CO_UNCONNECTED;

  (* SOFT_HLUTNM = "soft_lutpair0" *) 
  LUT5 #(
    .INIT(32'h33AF33A0)) 
    \FSM_sequential_fsm_state[0]_i_1 
       (.I0(fsm_state0_carry__0_n_0),
        .I1(fsm_state0__7_carry__0_n_0),
        .I2(fsm_state[1]),
        .I3(fsm_state[0]),
        .I4(p_0_in),
        .O(\FSM_sequential_fsm_state[0]_i_1_n_0 ));
  (* SOFT_HLUTNM = "soft_lutpair0" *) 
  LUT3 #(
    .INIT(8'h6C)) 
    \FSM_sequential_fsm_state[1]_i_1 
       (.I0(fsm_state0__7_carry__0_n_0),
        .I1(fsm_state[1]),
        .I2(fsm_state[0]),
        .O(\FSM_sequential_fsm_state[1]_i_1_n_0 ));
  (* FSM_ENCODED_STATES = "state_h2l:11,state_low:00,state_high:10,state_l2h:01" *) 
  FDRE #(
    .INIT(1'b0)) 
    \FSM_sequential_fsm_state_reg[0] 
       (.C(clk_in),
        .CE(1'b1),
        .D(\FSM_sequential_fsm_state[0]_i_1_n_0 ),
        .Q(fsm_state[0]),
        .R(1'b0));
  (* FSM_ENCODED_STATES = "state_h2l:11,state_low:00,state_high:10,state_l2h:01" *) 
  FDRE #(
    .INIT(1'b0)) 
    \FSM_sequential_fsm_state_reg[1] 
       (.C(clk_in),
        .CE(1'b1),
        .D(\FSM_sequential_fsm_state[1]_i_1_n_0 ),
        .Q(fsm_state[1]),
        .R(1'b0));
  LUT1 #(
    .INIT(2'h1)) 
    \counter_reg[0]_i_1 
       (.I0(\counter_reg_reg_n_0_[0] ),
        .O(\counter_reg[0]_i_1_n_0 ));
  LUT1 #(
    .INIT(2'h1)) 
    \counter_reg[15]_i_1 
       (.I0(fsm_state[0]),
        .O(\counter_reg[15]_i_1_n_0 ));
  FDRE #(
    .INIT(1'b0)) 
    \counter_reg_reg[0] 
       (.C(clk_in),
        .CE(1'b1),
        .D(\counter_reg[0]_i_1_n_0 ),
        .Q(\counter_reg_reg_n_0_[0] ),
        .R(\counter_reg[15]_i_1_n_0 ));
  FDRE #(
    .INIT(1'b0)) 
    \counter_reg_reg[10] 
       (.C(clk_in),
        .CE(1'b1),
        .D(in4[10]),
        .Q(\counter_reg_reg_n_0_[10] ),
        .R(\counter_reg[15]_i_1_n_0 ));
  FDRE #(
    .INIT(1'b0)) 
    \counter_reg_reg[11] 
       (.C(clk_in),
        .CE(1'b1),
        .D(in4[11]),
        .Q(\counter_reg_reg_n_0_[11] ),
        .R(\counter_reg[15]_i_1_n_0 ));
  FDRE #(
    .INIT(1'b0)) 
    \counter_reg_reg[12] 
       (.C(clk_in),
        .CE(1'b1),
        .D(in4[12]),
        .Q(\counter_reg_reg_n_0_[12] ),
        .R(\counter_reg[15]_i_1_n_0 ));
  CARRY4 \counter_reg_reg[12]_i_1 
       (.CI(\counter_reg_reg[8]_i_1_n_0 ),
        .CO({\counter_reg_reg[12]_i_1_n_0 ,\counter_reg_reg[12]_i_1_n_1 ,\counter_reg_reg[12]_i_1_n_2 ,\counter_reg_reg[12]_i_1_n_3 }),
        .CYINIT(1'b0),
        .DI({1'b0,1'b0,1'b0,1'b0}),
        .O(in4[12:9]),
        .S({\counter_reg_reg_n_0_[12] ,\counter_reg_reg_n_0_[11] ,\counter_reg_reg_n_0_[10] ,\counter_reg_reg_n_0_[9] }));
  FDRE #(
    .INIT(1'b0)) 
    \counter_reg_reg[13] 
       (.C(clk_in),
        .CE(1'b1),
        .D(in4[13]),
        .Q(\counter_reg_reg_n_0_[13] ),
        .R(\counter_reg[15]_i_1_n_0 ));
  FDRE #(
    .INIT(1'b0)) 
    \counter_reg_reg[14] 
       (.C(clk_in),
        .CE(1'b1),
        .D(in4[14]),
        .Q(\counter_reg_reg_n_0_[14] ),
        .R(\counter_reg[15]_i_1_n_0 ));
  FDRE #(
    .INIT(1'b0)) 
    \counter_reg_reg[15] 
       (.C(clk_in),
        .CE(1'b1),
        .D(in4[15]),
        .Q(\counter_reg_reg_n_0_[15] ),
        .R(\counter_reg[15]_i_1_n_0 ));
  CARRY4 \counter_reg_reg[15]_i_2 
       (.CI(\counter_reg_reg[12]_i_1_n_0 ),
        .CO({\NLW_counter_reg_reg[15]_i_2_CO_UNCONNECTED [3:2],\counter_reg_reg[15]_i_2_n_2 ,\counter_reg_reg[15]_i_2_n_3 }),
        .CYINIT(1'b0),
        .DI({1'b0,1'b0,1'b0,1'b0}),
        .O({\NLW_counter_reg_reg[15]_i_2_O_UNCONNECTED [3],in4[15:13]}),
        .S({1'b0,\counter_reg_reg_n_0_[15] ,\counter_reg_reg_n_0_[14] ,\counter_reg_reg_n_0_[13] }));
  FDRE #(
    .INIT(1'b0)) 
    \counter_reg_reg[1] 
       (.C(clk_in),
        .CE(1'b1),
        .D(in4[1]),
        .Q(\counter_reg_reg_n_0_[1] ),
        .R(\counter_reg[15]_i_1_n_0 ));
  FDRE #(
    .INIT(1'b0)) 
    \counter_reg_reg[2] 
       (.C(clk_in),
        .CE(1'b1),
        .D(in4[2]),
        .Q(\counter_reg_reg_n_0_[2] ),
        .R(\counter_reg[15]_i_1_n_0 ));
  FDRE #(
    .INIT(1'b0)) 
    \counter_reg_reg[3] 
       (.C(clk_in),
        .CE(1'b1),
        .D(in4[3]),
        .Q(\counter_reg_reg_n_0_[3] ),
        .R(\counter_reg[15]_i_1_n_0 ));
  FDRE #(
    .INIT(1'b0)) 
    \counter_reg_reg[4] 
       (.C(clk_in),
        .CE(1'b1),
        .D(in4[4]),
        .Q(\counter_reg_reg_n_0_[4] ),
        .R(\counter_reg[15]_i_1_n_0 ));
  CARRY4 \counter_reg_reg[4]_i_1 
       (.CI(1'b0),
        .CO({\counter_reg_reg[4]_i_1_n_0 ,\counter_reg_reg[4]_i_1_n_1 ,\counter_reg_reg[4]_i_1_n_2 ,\counter_reg_reg[4]_i_1_n_3 }),
        .CYINIT(\counter_reg_reg_n_0_[0] ),
        .DI({1'b0,1'b0,1'b0,1'b0}),
        .O(in4[4:1]),
        .S({\counter_reg_reg_n_0_[4] ,\counter_reg_reg_n_0_[3] ,\counter_reg_reg_n_0_[2] ,\counter_reg_reg_n_0_[1] }));
  FDRE #(
    .INIT(1'b0)) 
    \counter_reg_reg[5] 
       (.C(clk_in),
        .CE(1'b1),
        .D(in4[5]),
        .Q(\counter_reg_reg_n_0_[5] ),
        .R(\counter_reg[15]_i_1_n_0 ));
  FDRE #(
    .INIT(1'b0)) 
    \counter_reg_reg[6] 
       (.C(clk_in),
        .CE(1'b1),
        .D(in4[6]),
        .Q(\counter_reg_reg_n_0_[6] ),
        .R(\counter_reg[15]_i_1_n_0 ));
  FDRE #(
    .INIT(1'b0)) 
    \counter_reg_reg[7] 
       (.C(clk_in),
        .CE(1'b1),
        .D(in4[7]),
        .Q(\counter_reg_reg_n_0_[7] ),
        .R(\counter_reg[15]_i_1_n_0 ));
  FDRE #(
    .INIT(1'b0)) 
    \counter_reg_reg[8] 
       (.C(clk_in),
        .CE(1'b1),
        .D(in4[8]),
        .Q(\counter_reg_reg_n_0_[8] ),
        .R(\counter_reg[15]_i_1_n_0 ));
  CARRY4 \counter_reg_reg[8]_i_1 
       (.CI(\counter_reg_reg[4]_i_1_n_0 ),
        .CO({\counter_reg_reg[8]_i_1_n_0 ,\counter_reg_reg[8]_i_1_n_1 ,\counter_reg_reg[8]_i_1_n_2 ,\counter_reg_reg[8]_i_1_n_3 }),
        .CYINIT(1'b0),
        .DI({1'b0,1'b0,1'b0,1'b0}),
        .O(in4[8:5]),
        .S({\counter_reg_reg_n_0_[8] ,\counter_reg_reg_n_0_[7] ,\counter_reg_reg_n_0_[6] ,\counter_reg_reg_n_0_[5] }));
  FDRE #(
    .INIT(1'b0)) 
    \counter_reg_reg[9] 
       (.C(clk_in),
        .CE(1'b1),
        .D(in4[9]),
        .Q(\counter_reg_reg_n_0_[9] ),
        .R(\counter_reg[15]_i_1_n_0 ));
  CARRY4 err_carry
       (.CI(1'b0),
        .CO({err_carry_n_0,err_carry_n_1,err_carry_n_2,err_carry_n_3}),
        .CYINIT(1'b1),
        .DI(meas_ff1[3:0]),
        .O(err_out[3:0]),
        .S({err_carry_i_1_n_0,err_carry_i_2_n_0,err_carry_i_3_n_0,err_carry_i_4_n_0}));
  CARRY4 err_carry__0
       (.CI(err_carry_n_0),
        .CO({err_carry__0_n_0,err_carry__0_n_1,err_carry__0_n_2,err_carry__0_n_3}),
        .CYINIT(1'b0),
        .DI(meas_ff1[7:4]),
        .O(err_out[7:4]),
        .S({err_carry__0_i_1_n_0,err_carry__0_i_2_n_0,err_carry__0_i_3_n_0,err_carry__0_i_4_n_0}));
  LUT2 #(
    .INIT(4'h9)) 
    err_carry__0_i_1
       (.I0(meas_ff1[7]),
        .I1(ref_ff2[7]),
        .O(err_carry__0_i_1_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    err_carry__0_i_2
       (.I0(meas_ff1[6]),
        .I1(ref_ff2[6]),
        .O(err_carry__0_i_2_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    err_carry__0_i_3
       (.I0(meas_ff1[5]),
        .I1(ref_ff2[5]),
        .O(err_carry__0_i_3_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    err_carry__0_i_4
       (.I0(meas_ff1[4]),
        .I1(ref_ff2[4]),
        .O(err_carry__0_i_4_n_0));
  CARRY4 err_carry__1
       (.CI(err_carry__0_n_0),
        .CO({err_carry__1_n_0,err_carry__1_n_1,err_carry__1_n_2,err_carry__1_n_3}),
        .CYINIT(1'b0),
        .DI(meas_ff1[11:8]),
        .O(err_out[11:8]),
        .S({err_carry__1_i_1_n_0,err_carry__1_i_2_n_0,err_carry__1_i_3_n_0,err_carry__1_i_4_n_0}));
  LUT2 #(
    .INIT(4'h9)) 
    err_carry__1_i_1
       (.I0(meas_ff1[11]),
        .I1(ref_ff2[11]),
        .O(err_carry__1_i_1_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    err_carry__1_i_2
       (.I0(meas_ff1[10]),
        .I1(ref_ff2[10]),
        .O(err_carry__1_i_2_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    err_carry__1_i_3
       (.I0(meas_ff1[9]),
        .I1(ref_ff2[9]),
        .O(err_carry__1_i_3_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    err_carry__1_i_4
       (.I0(meas_ff1[8]),
        .I1(ref_ff2[8]),
        .O(err_carry__1_i_4_n_0));
  CARRY4 err_carry__2
       (.CI(err_carry__1_n_0),
        .CO({NLW_err_carry__2_CO_UNCONNECTED[3],err_carry__2_n_1,err_carry__2_n_2,err_carry__2_n_3}),
        .CYINIT(1'b0),
        .DI({1'b0,meas_ff1[14:12]}),
        .O(err_out[15:12]),
        .S({err_carry__2_i_1_n_0,err_carry__2_i_2_n_0,err_carry__2_i_3_n_0,err_carry__2_i_4_n_0}));
  LUT2 #(
    .INIT(4'h9)) 
    err_carry__2_i_1
       (.I0(meas_ff1[15]),
        .I1(ref_ff2[15]),
        .O(err_carry__2_i_1_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    err_carry__2_i_2
       (.I0(meas_ff1[14]),
        .I1(ref_ff2[14]),
        .O(err_carry__2_i_2_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    err_carry__2_i_3
       (.I0(meas_ff1[13]),
        .I1(ref_ff2[13]),
        .O(err_carry__2_i_3_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    err_carry__2_i_4
       (.I0(meas_ff1[12]),
        .I1(ref_ff2[12]),
        .O(err_carry__2_i_4_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    err_carry_i_1
       (.I0(meas_ff1[3]),
        .I1(ref_ff2[3]),
        .O(err_carry_i_1_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    err_carry_i_2
       (.I0(meas_ff1[2]),
        .I1(ref_ff2[2]),
        .O(err_carry_i_2_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    err_carry_i_3
       (.I0(meas_ff1[1]),
        .I1(ref_ff2[1]),
        .O(err_carry_i_3_n_0));
  LUT2 #(
    .INIT(4'h9)) 
    err_carry_i_4
       (.I0(meas_ff1[0]),
        .I1(ref_ff2[0]),
        .O(err_carry_i_4_n_0));
  CARRY4 fsm_state0__15_carry
       (.CI(1'b0),
        .CO({fsm_state0__15_carry_n_0,fsm_state0__15_carry_n_1,fsm_state0__15_carry_n_2,fsm_state0__15_carry_n_3}),
        .CYINIT(1'b0),
        .DI({fsm_state0__15_carry_i_1_n_0,fsm_state0__15_carry_i_2_n_0,fsm_state0__15_carry_i_3_n_0,fsm_state0__15_carry_i_4_n_0}),
        .O(NLW_fsm_state0__15_carry_O_UNCONNECTED[3:0]),
        .S({fsm_state0__15_carry_i_5_n_0,fsm_state0__15_carry_i_6_n_0,fsm_state0__15_carry_i_7_n_0,fsm_state0__15_carry_i_8_n_0}));
  CARRY4 fsm_state0__15_carry__0
       (.CI(fsm_state0__15_carry_n_0),
        .CO({p_0_in,fsm_state0__15_carry__0_n_1,fsm_state0__15_carry__0_n_2,fsm_state0__15_carry__0_n_3}),
        .CYINIT(1'b0),
        .DI({fsm_state0__15_carry_i_1__0_n_0,fsm_state0__15_carry_i_2__0_n_0,fsm_state0__15_carry_i_3__0_n_0,fsm_state0__15_carry_i_4__0_n_0}),
        .O(NLW_fsm_state0__15_carry__0_O_UNCONNECTED[3:0]),
        .S({fsm_state0__15_carry_i_5__0_n_0,fsm_state0__15_carry_i_6__0_n_0,fsm_state0__15_carry_i_7__0_n_0,fsm_state0__15_carry_i_8__0_n_0}));
  LUT4 #(
    .INIT(16'h2F02)) 
    fsm_state0__15_carry_i_1
       (.I0(err_out[6]),
        .I1(tol_ff2[6]),
        .I2(tol_ff2[7]),
        .I3(err_out[7]),
        .O(fsm_state0__15_carry_i_1_n_0));
  LUT4 #(
    .INIT(16'h2F02)) 
    fsm_state0__15_carry_i_1__0
       (.I0(err_out[14]),
        .I1(tol_ff2[14]),
        .I2(err_out[15]),
        .I3(tol_ff2[15]),
        .O(fsm_state0__15_carry_i_1__0_n_0));
  LUT4 #(
    .INIT(16'h2F02)) 
    fsm_state0__15_carry_i_2
       (.I0(err_out[4]),
        .I1(tol_ff2[4]),
        .I2(tol_ff2[5]),
        .I3(err_out[5]),
        .O(fsm_state0__15_carry_i_2_n_0));
  LUT4 #(
    .INIT(16'h2F02)) 
    fsm_state0__15_carry_i_2__0
       (.I0(err_out[12]),
        .I1(tol_ff2[12]),
        .I2(tol_ff2[13]),
        .I3(err_out[13]),
        .O(fsm_state0__15_carry_i_2__0_n_0));
  LUT4 #(
    .INIT(16'h2F02)) 
    fsm_state0__15_carry_i_3
       (.I0(err_out[2]),
        .I1(tol_ff2[2]),
        .I2(tol_ff2[3]),
        .I3(err_out[3]),
        .O(fsm_state0__15_carry_i_3_n_0));
  LUT4 #(
    .INIT(16'h2F02)) 
    fsm_state0__15_carry_i_3__0
       (.I0(err_out[10]),
        .I1(tol_ff2[10]),
        .I2(tol_ff2[11]),
        .I3(err_out[11]),
        .O(fsm_state0__15_carry_i_3__0_n_0));
  LUT4 #(
    .INIT(16'h2F02)) 
    fsm_state0__15_carry_i_4
       (.I0(err_out[0]),
        .I1(tol_ff2[0]),
        .I2(tol_ff2[1]),
        .I3(err_out[1]),
        .O(fsm_state0__15_carry_i_4_n_0));
  LUT4 #(
    .INIT(16'h2F02)) 
    fsm_state0__15_carry_i_4__0
       (.I0(err_out[8]),
        .I1(tol_ff2[8]),
        .I2(tol_ff2[9]),
        .I3(err_out[9]),
        .O(fsm_state0__15_carry_i_4__0_n_0));
  LUT4 #(
    .INIT(16'h9009)) 
    fsm_state0__15_carry_i_5
       (.I0(err_out[6]),
        .I1(tol_ff2[6]),
        .I2(err_out[7]),
        .I3(tol_ff2[7]),
        .O(fsm_state0__15_carry_i_5_n_0));
  LUT4 #(
    .INIT(16'h9009)) 
    fsm_state0__15_carry_i_5__0
       (.I0(err_out[14]),
        .I1(tol_ff2[14]),
        .I2(tol_ff2[15]),
        .I3(err_out[15]),
        .O(fsm_state0__15_carry_i_5__0_n_0));
  LUT4 #(
    .INIT(16'h9009)) 
    fsm_state0__15_carry_i_6
       (.I0(err_out[4]),
        .I1(tol_ff2[4]),
        .I2(err_out[5]),
        .I3(tol_ff2[5]),
        .O(fsm_state0__15_carry_i_6_n_0));
  LUT4 #(
    .INIT(16'h9009)) 
    fsm_state0__15_carry_i_6__0
       (.I0(err_out[12]),
        .I1(tol_ff2[12]),
        .I2(err_out[13]),
        .I3(tol_ff2[13]),
        .O(fsm_state0__15_carry_i_6__0_n_0));
  LUT4 #(
    .INIT(16'h9009)) 
    fsm_state0__15_carry_i_7
       (.I0(err_out[2]),
        .I1(tol_ff2[2]),
        .I2(err_out[3]),
        .I3(tol_ff2[3]),
        .O(fsm_state0__15_carry_i_7_n_0));
  LUT4 #(
    .INIT(16'h9009)) 
    fsm_state0__15_carry_i_7__0
       (.I0(err_out[10]),
        .I1(tol_ff2[10]),
        .I2(err_out[11]),
        .I3(tol_ff2[11]),
        .O(fsm_state0__15_carry_i_7__0_n_0));
  LUT4 #(
    .INIT(16'h9009)) 
    fsm_state0__15_carry_i_8
       (.I0(err_out[0]),
        .I1(tol_ff2[0]),
        .I2(err_out[1]),
        .I3(tol_ff2[1]),
        .O(fsm_state0__15_carry_i_8_n_0));
  LUT4 #(
    .INIT(16'h9009)) 
    fsm_state0__15_carry_i_8__0
       (.I0(err_out[8]),
        .I1(tol_ff2[8]),
        .I2(err_out[9]),
        .I3(tol_ff2[9]),
        .O(fsm_state0__15_carry_i_8__0_n_0));
  CARRY4 fsm_state0__7_carry
       (.CI(1'b0),
        .CO({fsm_state0__7_carry_n_0,fsm_state0__7_carry_n_1,fsm_state0__7_carry_n_2,fsm_state0__7_carry_n_3}),
        .CYINIT(1'b1),
        .DI({fsm_state0__7_carry_i_1_n_0,fsm_state0__7_carry_i_2_n_0,fsm_state0__7_carry_i_3_n_0,fsm_state0__7_carry_i_4_n_0}),
        .O(NLW_fsm_state0__7_carry_O_UNCONNECTED[3:0]),
        .S({fsm_state0__7_carry_i_5_n_0,fsm_state0__7_carry_i_6_n_0,fsm_state0__7_carry_i_7_n_0,fsm_state0__7_carry_i_8_n_0}));
  CARRY4 fsm_state0__7_carry__0
       (.CI(fsm_state0__7_carry_n_0),
        .CO({fsm_state0__7_carry__0_n_0,fsm_state0__7_carry__0_n_1,fsm_state0__7_carry__0_n_2,fsm_state0__7_carry__0_n_3}),
        .CYINIT(1'b0),
        .DI({fsm_state0__7_carry__0_i_1_n_0,fsm_state0__7_carry__0_i_2_n_0,fsm_state0__7_carry__0_i_3_n_0,fsm_state0__7_carry__0_i_4_n_0}),
        .O(NLW_fsm_state0__7_carry__0_O_UNCONNECTED[3:0]),
        .S({fsm_state0__7_carry__0_i_5_n_0,fsm_state0__7_carry__0_i_6_n_0,fsm_state0__7_carry__0_i_7_n_0,fsm_state0__7_carry__0_i_8_n_0}));
  LUT4 #(
    .INIT(16'h2F02)) 
    fsm_state0__7_carry__0_i_1
       (.I0(\counter_reg_reg_n_0_[14] ),
        .I1(delay_in[14]),
        .I2(delay_in[15]),
        .I3(\counter_reg_reg_n_0_[15] ),
        .O(fsm_state0__7_carry__0_i_1_n_0));
  LUT4 #(
    .INIT(16'h2F02)) 
    fsm_state0__7_carry__0_i_2
       (.I0(\counter_reg_reg_n_0_[12] ),
        .I1(delay_in[12]),
        .I2(delay_in[13]),
        .I3(\counter_reg_reg_n_0_[13] ),
        .O(fsm_state0__7_carry__0_i_2_n_0));
  LUT4 #(
    .INIT(16'h2F02)) 
    fsm_state0__7_carry__0_i_3
       (.I0(\counter_reg_reg_n_0_[10] ),
        .I1(delay_in[10]),
        .I2(delay_in[11]),
        .I3(\counter_reg_reg_n_0_[11] ),
        .O(fsm_state0__7_carry__0_i_3_n_0));
  LUT4 #(
    .INIT(16'h2F02)) 
    fsm_state0__7_carry__0_i_4
       (.I0(\counter_reg_reg_n_0_[8] ),
        .I1(delay_in[8]),
        .I2(delay_in[9]),
        .I3(\counter_reg_reg_n_0_[9] ),
        .O(fsm_state0__7_carry__0_i_4_n_0));
  LUT4 #(
    .INIT(16'h9009)) 
    fsm_state0__7_carry__0_i_5
       (.I0(\counter_reg_reg_n_0_[14] ),
        .I1(delay_in[14]),
        .I2(\counter_reg_reg_n_0_[15] ),
        .I3(delay_in[15]),
        .O(fsm_state0__7_carry__0_i_5_n_0));
  LUT4 #(
    .INIT(16'h9009)) 
    fsm_state0__7_carry__0_i_6
       (.I0(\counter_reg_reg_n_0_[12] ),
        .I1(delay_in[12]),
        .I2(\counter_reg_reg_n_0_[13] ),
        .I3(delay_in[13]),
        .O(fsm_state0__7_carry__0_i_6_n_0));
  LUT4 #(
    .INIT(16'h9009)) 
    fsm_state0__7_carry__0_i_7
       (.I0(\counter_reg_reg_n_0_[10] ),
        .I1(delay_in[10]),
        .I2(\counter_reg_reg_n_0_[11] ),
        .I3(delay_in[11]),
        .O(fsm_state0__7_carry__0_i_7_n_0));
  LUT4 #(
    .INIT(16'h9009)) 
    fsm_state0__7_carry__0_i_8
       (.I0(\counter_reg_reg_n_0_[8] ),
        .I1(delay_in[8]),
        .I2(\counter_reg_reg_n_0_[9] ),
        .I3(delay_in[9]),
        .O(fsm_state0__7_carry__0_i_8_n_0));
  LUT4 #(
    .INIT(16'h2F02)) 
    fsm_state0__7_carry_i_1
       (.I0(\counter_reg_reg_n_0_[6] ),
        .I1(delay_in[6]),
        .I2(delay_in[7]),
        .I3(\counter_reg_reg_n_0_[7] ),
        .O(fsm_state0__7_carry_i_1_n_0));
  LUT4 #(
    .INIT(16'h2F02)) 
    fsm_state0__7_carry_i_2
       (.I0(\counter_reg_reg_n_0_[4] ),
        .I1(delay_in[4]),
        .I2(delay_in[5]),
        .I3(\counter_reg_reg_n_0_[5] ),
        .O(fsm_state0__7_carry_i_2_n_0));
  LUT4 #(
    .INIT(16'h2F02)) 
    fsm_state0__7_carry_i_3
       (.I0(\counter_reg_reg_n_0_[2] ),
        .I1(delay_in[2]),
        .I2(delay_in[3]),
        .I3(\counter_reg_reg_n_0_[3] ),
        .O(fsm_state0__7_carry_i_3_n_0));
  LUT4 #(
    .INIT(16'h2F02)) 
    fsm_state0__7_carry_i_4
       (.I0(\counter_reg_reg_n_0_[0] ),
        .I1(delay_in[0]),
        .I2(delay_in[1]),
        .I3(\counter_reg_reg_n_0_[1] ),
        .O(fsm_state0__7_carry_i_4_n_0));
  LUT4 #(
    .INIT(16'h9009)) 
    fsm_state0__7_carry_i_5
       (.I0(\counter_reg_reg_n_0_[6] ),
        .I1(delay_in[6]),
        .I2(\counter_reg_reg_n_0_[7] ),
        .I3(delay_in[7]),
        .O(fsm_state0__7_carry_i_5_n_0));
  LUT4 #(
    .INIT(16'h9009)) 
    fsm_state0__7_carry_i_6
       (.I0(\counter_reg_reg_n_0_[4] ),
        .I1(delay_in[4]),
        .I2(\counter_reg_reg_n_0_[5] ),
        .I3(delay_in[5]),
        .O(fsm_state0__7_carry_i_6_n_0));
  LUT4 #(
    .INIT(16'h9009)) 
    fsm_state0__7_carry_i_7
       (.I0(\counter_reg_reg_n_0_[2] ),
        .I1(delay_in[2]),
        .I2(\counter_reg_reg_n_0_[3] ),
        .I3(delay_in[3]),
        .O(fsm_state0__7_carry_i_7_n_0));
  LUT4 #(
    .INIT(16'h9009)) 
    fsm_state0__7_carry_i_8
       (.I0(\counter_reg_reg_n_0_[0] ),
        .I1(delay_in[0]),
        .I2(\counter_reg_reg_n_0_[1] ),
        .I3(delay_in[1]),
        .O(fsm_state0__7_carry_i_8_n_0));
  CARRY4 fsm_state0_carry
       (.CI(1'b0),
        .CO({fsm_state0_carry_n_0,fsm_state0_carry_n_1,fsm_state0_carry_n_2,fsm_state0_carry_n_3}),
        .CYINIT(1'b0),
        .DI({fsm_state0_carry_i_1_n_0,fsm_state0_carry_i_2_n_0,fsm_state0_carry_i_3_n_0,fsm_state0_carry_i_4_n_0}),
        .O(NLW_fsm_state0_carry_O_UNCONNECTED[3:0]),
        .S({fsm_state0_carry_i_5_n_0,fsm_state0_carry_i_6_n_0,fsm_state0_carry_i_7_n_0,fsm_state0_carry_i_8_n_0}));
  CARRY4 fsm_state0_carry__0
       (.CI(fsm_state0_carry_n_0),
        .CO({fsm_state0_carry__0_n_0,fsm_state0_carry__0_n_1,fsm_state0_carry__0_n_2,fsm_state0_carry__0_n_3}),
        .CYINIT(1'b0),
        .DI({fsm_state0_carry__0_i_1_n_0,fsm_state0_carry__0_i_2_n_0,fsm_state0_carry__0_i_3_n_0,fsm_state0_carry__0_i_4_n_0}),
        .O(NLW_fsm_state0_carry__0_O_UNCONNECTED[3:0]),
        .S({fsm_state0_carry__0_i_5_n_0,fsm_state0_carry__0_i_6_n_0,fsm_state0_carry__0_i_7_n_0,fsm_state0_carry__0_i_8_n_0}));
  LUT4 #(
    .INIT(16'h2F02)) 
    fsm_state0_carry__0_i_1
       (.I0(fsm_state1[14]),
        .I1(err_out[14]),
        .I2(fsm_state1[15]),
        .I3(err_out[15]),
        .O(fsm_state0_carry__0_i_1_n_0));
  LUT4 #(
    .INIT(16'h2F02)) 
    fsm_state0_carry__0_i_2
       (.I0(fsm_state1[12]),
        .I1(err_out[12]),
        .I2(err_out[13]),
        .I3(fsm_state1[13]),
        .O(fsm_state0_carry__0_i_2_n_0));
  LUT4 #(
    .INIT(16'h2F02)) 
    fsm_state0_carry__0_i_3
       (.I0(fsm_state1[10]),
        .I1(err_out[10]),
        .I2(err_out[11]),
        .I3(fsm_state1[11]),
        .O(fsm_state0_carry__0_i_3_n_0));
  LUT4 #(
    .INIT(16'h2F02)) 
    fsm_state0_carry__0_i_4
       (.I0(fsm_state1[8]),
        .I1(err_out[8]),
        .I2(err_out[9]),
        .I3(fsm_state1[9]),
        .O(fsm_state0_carry__0_i_4_n_0));
  LUT4 #(
    .INIT(16'h9009)) 
    fsm_state0_carry__0_i_5
       (.I0(fsm_state1[14]),
        .I1(err_out[14]),
        .I2(err_out[15]),
        .I3(fsm_state1[15]),
        .O(fsm_state0_carry__0_i_5_n_0));
  LUT4 #(
    .INIT(16'h9009)) 
    fsm_state0_carry__0_i_6
       (.I0(fsm_state1[12]),
        .I1(err_out[12]),
        .I2(fsm_state1[13]),
        .I3(err_out[13]),
        .O(fsm_state0_carry__0_i_6_n_0));
  LUT4 #(
    .INIT(16'h9009)) 
    fsm_state0_carry__0_i_7
       (.I0(fsm_state1[10]),
        .I1(err_out[10]),
        .I2(fsm_state1[11]),
        .I3(err_out[11]),
        .O(fsm_state0_carry__0_i_7_n_0));
  LUT4 #(
    .INIT(16'h9009)) 
    fsm_state0_carry__0_i_8
       (.I0(fsm_state1[8]),
        .I1(err_out[8]),
        .I2(fsm_state1[9]),
        .I3(err_out[9]),
        .O(fsm_state0_carry__0_i_8_n_0));
  LUT4 #(
    .INIT(16'h2F02)) 
    fsm_state0_carry_i_1
       (.I0(fsm_state1[6]),
        .I1(err_out[6]),
        .I2(err_out[7]),
        .I3(fsm_state1[7]),
        .O(fsm_state0_carry_i_1_n_0));
  LUT4 #(
    .INIT(16'h2F02)) 
    fsm_state0_carry_i_2
       (.I0(fsm_state1[4]),
        .I1(err_out[4]),
        .I2(err_out[5]),
        .I3(fsm_state1[5]),
        .O(fsm_state0_carry_i_2_n_0));
  LUT4 #(
    .INIT(16'h2F02)) 
    fsm_state0_carry_i_3
       (.I0(fsm_state1[2]),
        .I1(err_out[2]),
        .I2(err_out[3]),
        .I3(fsm_state1[3]),
        .O(fsm_state0_carry_i_3_n_0));
  LUT4 #(
    .INIT(16'h2F02)) 
    fsm_state0_carry_i_4
       (.I0(fsm_state1[0]),
        .I1(err_out[0]),
        .I2(err_out[1]),
        .I3(fsm_state1[1]),
        .O(fsm_state0_carry_i_4_n_0));
  LUT4 #(
    .INIT(16'h9009)) 
    fsm_state0_carry_i_5
       (.I0(fsm_state1[6]),
        .I1(err_out[6]),
        .I2(fsm_state1[7]),
        .I3(err_out[7]),
        .O(fsm_state0_carry_i_5_n_0));
  LUT4 #(
    .INIT(16'h9009)) 
    fsm_state0_carry_i_6
       (.I0(fsm_state1[4]),
        .I1(err_out[4]),
        .I2(fsm_state1[5]),
        .I3(err_out[5]),
        .O(fsm_state0_carry_i_6_n_0));
  LUT4 #(
    .INIT(16'h9009)) 
    fsm_state0_carry_i_7
       (.I0(fsm_state1[2]),
        .I1(err_out[2]),
        .I2(fsm_state1[3]),
        .I3(err_out[3]),
        .O(fsm_state0_carry_i_7_n_0));
  LUT4 #(
    .INIT(16'h9009)) 
    fsm_state0_carry_i_8
       (.I0(fsm_state1[0]),
        .I1(err_out[0]),
        .I2(fsm_state1[1]),
        .I3(err_out[1]),
        .O(fsm_state0_carry_i_8_n_0));
  CARRY4 fsm_state1_carry
       (.CI(1'b0),
        .CO({fsm_state1_carry_n_0,fsm_state1_carry_n_1,fsm_state1_carry_n_2,fsm_state1_carry_n_3}),
        .CYINIT(1'b0),
        .DI({1'b0,1'b0,1'b0,1'b1}),
        .O(fsm_state1[3:0]),
        .S({fsm_state1_carry_i_1_n_0,fsm_state1_carry_i_2_n_0,fsm_state1_carry_i_3_n_0,tol_ff2[0]}));
  CARRY4 fsm_state1_carry__0
       (.CI(fsm_state1_carry_n_0),
        .CO({fsm_state1_carry__0_n_0,fsm_state1_carry__0_n_1,fsm_state1_carry__0_n_2,fsm_state1_carry__0_n_3}),
        .CYINIT(1'b0),
        .DI({1'b0,1'b0,1'b0,1'b0}),
        .O(fsm_state1[7:4]),
        .S({fsm_state1_carry__0_i_1_n_0,fsm_state1_carry__0_i_2_n_0,fsm_state1_carry__0_i_3_n_0,fsm_state1_carry__0_i_4_n_0}));
  LUT1 #(
    .INIT(2'h1)) 
    fsm_state1_carry__0_i_1
       (.I0(tol_ff2[7]),
        .O(fsm_state1_carry__0_i_1_n_0));
  LUT1 #(
    .INIT(2'h1)) 
    fsm_state1_carry__0_i_2
       (.I0(tol_ff2[6]),
        .O(fsm_state1_carry__0_i_2_n_0));
  LUT1 #(
    .INIT(2'h1)) 
    fsm_state1_carry__0_i_3
       (.I0(tol_ff2[5]),
        .O(fsm_state1_carry__0_i_3_n_0));
  LUT1 #(
    .INIT(2'h1)) 
    fsm_state1_carry__0_i_4
       (.I0(tol_ff2[4]),
        .O(fsm_state1_carry__0_i_4_n_0));
  CARRY4 fsm_state1_carry__1
       (.CI(fsm_state1_carry__0_n_0),
        .CO({fsm_state1_carry__1_n_0,fsm_state1_carry__1_n_1,fsm_state1_carry__1_n_2,fsm_state1_carry__1_n_3}),
        .CYINIT(1'b0),
        .DI({1'b0,1'b0,1'b0,1'b0}),
        .O(fsm_state1[11:8]),
        .S({fsm_state1_carry__1_i_1_n_0,fsm_state1_carry__1_i_2_n_0,fsm_state1_carry__1_i_3_n_0,fsm_state1_carry__1_i_4_n_0}));
  LUT1 #(
    .INIT(2'h1)) 
    fsm_state1_carry__1_i_1
       (.I0(tol_ff2[11]),
        .O(fsm_state1_carry__1_i_1_n_0));
  LUT1 #(
    .INIT(2'h1)) 
    fsm_state1_carry__1_i_2
       (.I0(tol_ff2[10]),
        .O(fsm_state1_carry__1_i_2_n_0));
  LUT1 #(
    .INIT(2'h1)) 
    fsm_state1_carry__1_i_3
       (.I0(tol_ff2[9]),
        .O(fsm_state1_carry__1_i_3_n_0));
  LUT1 #(
    .INIT(2'h1)) 
    fsm_state1_carry__1_i_4
       (.I0(tol_ff2[8]),
        .O(fsm_state1_carry__1_i_4_n_0));
  CARRY4 fsm_state1_carry__2
       (.CI(fsm_state1_carry__1_n_0),
        .CO({NLW_fsm_state1_carry__2_CO_UNCONNECTED[3],fsm_state1_carry__2_n_1,fsm_state1_carry__2_n_2,fsm_state1_carry__2_n_3}),
        .CYINIT(1'b0),
        .DI({1'b0,1'b0,1'b0,1'b0}),
        .O(fsm_state1[15:12]),
        .S({fsm_state1_carry__2_i_1_n_0,fsm_state1_carry__2_i_2_n_0,fsm_state1_carry__2_i_3_n_0,fsm_state1_carry__2_i_4_n_0}));
  LUT1 #(
    .INIT(2'h1)) 
    fsm_state1_carry__2_i_1
       (.I0(tol_ff2[15]),
        .O(fsm_state1_carry__2_i_1_n_0));
  LUT1 #(
    .INIT(2'h1)) 
    fsm_state1_carry__2_i_2
       (.I0(tol_ff2[14]),
        .O(fsm_state1_carry__2_i_2_n_0));
  LUT1 #(
    .INIT(2'h1)) 
    fsm_state1_carry__2_i_3
       (.I0(tol_ff2[13]),
        .O(fsm_state1_carry__2_i_3_n_0));
  LUT1 #(
    .INIT(2'h1)) 
    fsm_state1_carry__2_i_4
       (.I0(tol_ff2[12]),
        .O(fsm_state1_carry__2_i_4_n_0));
  LUT1 #(
    .INIT(2'h1)) 
    fsm_state1_carry_i_1
       (.I0(tol_ff2[3]),
        .O(fsm_state1_carry_i_1_n_0));
  LUT1 #(
    .INIT(2'h1)) 
    fsm_state1_carry_i_2
       (.I0(tol_ff2[2]),
        .O(fsm_state1_carry_i_2_n_0));
  LUT1 #(
    .INIT(2'h1)) 
    fsm_state1_carry_i_3
       (.I0(tol_ff2[1]),
        .O(fsm_state1_carry_i_3_n_0));
  FDRE #(
    .INIT(1'b0)) 
    \meas_ff1_reg[0] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(meas_in[0]),
        .Q(meas_ff1[0]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \meas_ff1_reg[10] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(meas_in[10]),
        .Q(meas_ff1[10]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \meas_ff1_reg[11] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(meas_in[11]),
        .Q(meas_ff1[11]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \meas_ff1_reg[12] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(meas_in[12]),
        .Q(meas_ff1[12]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \meas_ff1_reg[13] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(meas_in[13]),
        .Q(meas_ff1[13]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \meas_ff1_reg[14] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(meas_in[14]),
        .Q(meas_ff1[14]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \meas_ff1_reg[15] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(meas_in[15]),
        .Q(meas_ff1[15]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \meas_ff1_reg[1] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(meas_in[1]),
        .Q(meas_ff1[1]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \meas_ff1_reg[2] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(meas_in[2]),
        .Q(meas_ff1[2]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \meas_ff1_reg[3] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(meas_in[3]),
        .Q(meas_ff1[3]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \meas_ff1_reg[4] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(meas_in[4]),
        .Q(meas_ff1[4]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \meas_ff1_reg[5] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(meas_in[5]),
        .Q(meas_ff1[5]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \meas_ff1_reg[6] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(meas_in[6]),
        .Q(meas_ff1[6]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \meas_ff1_reg[7] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(meas_in[7]),
        .Q(meas_ff1[7]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \meas_ff1_reg[8] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(meas_in[8]),
        .Q(meas_ff1[8]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \meas_ff1_reg[9] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(meas_in[9]),
        .Q(meas_ff1[9]),
        .R(1'b0));
  LUT2 #(
    .INIT(4'h9)) 
    pwm_out_i_1
       (.I0(fsm_state[1]),
        .I1(fsm_state[0]),
        .O(pwm_out_i_1_n_0));
  FDRE pwm_out_reg
       (.C(clk_in),
        .CE(1'b1),
        .D(pwm_out_i_1_n_0),
        .Q(pwm_out),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff1_reg[0] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(ref_in[0]),
        .Q(ref_ff1[0]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff1_reg[10] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(ref_in[10]),
        .Q(ref_ff1[10]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff1_reg[11] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(ref_in[11]),
        .Q(ref_ff1[11]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff1_reg[12] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(ref_in[12]),
        .Q(ref_ff1[12]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff1_reg[13] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(ref_in[13]),
        .Q(ref_ff1[13]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff1_reg[14] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(ref_in[14]),
        .Q(ref_ff1[14]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff1_reg[15] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(ref_in[15]),
        .Q(ref_ff1[15]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff1_reg[1] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(ref_in[1]),
        .Q(ref_ff1[1]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff1_reg[2] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(ref_in[2]),
        .Q(ref_ff1[2]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff1_reg[3] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(ref_in[3]),
        .Q(ref_ff1[3]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff1_reg[4] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(ref_in[4]),
        .Q(ref_ff1[4]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff1_reg[5] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(ref_in[5]),
        .Q(ref_ff1[5]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff1_reg[6] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(ref_in[6]),
        .Q(ref_ff1[6]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff1_reg[7] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(ref_in[7]),
        .Q(ref_ff1[7]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff1_reg[8] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(ref_in[8]),
        .Q(ref_ff1[8]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff1_reg[9] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(ref_in[9]),
        .Q(ref_ff1[9]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff2_reg[0] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(ref_ff1[0]),
        .Q(ref_ff2[0]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff2_reg[10] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(ref_ff1[10]),
        .Q(ref_ff2[10]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff2_reg[11] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(ref_ff1[11]),
        .Q(ref_ff2[11]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff2_reg[12] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(ref_ff1[12]),
        .Q(ref_ff2[12]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff2_reg[13] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(ref_ff1[13]),
        .Q(ref_ff2[13]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff2_reg[14] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(ref_ff1[14]),
        .Q(ref_ff2[14]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff2_reg[15] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(ref_ff1[15]),
        .Q(ref_ff2[15]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff2_reg[1] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(ref_ff1[1]),
        .Q(ref_ff2[1]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff2_reg[2] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(ref_ff1[2]),
        .Q(ref_ff2[2]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff2_reg[3] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(ref_ff1[3]),
        .Q(ref_ff2[3]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff2_reg[4] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(ref_ff1[4]),
        .Q(ref_ff2[4]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff2_reg[5] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(ref_ff1[5]),
        .Q(ref_ff2[5]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff2_reg[6] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(ref_ff1[6]),
        .Q(ref_ff2[6]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff2_reg[7] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(ref_ff1[7]),
        .Q(ref_ff2[7]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff2_reg[8] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(ref_ff1[8]),
        .Q(ref_ff2[8]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \ref_ff2_reg[9] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(ref_ff1[9]),
        .Q(ref_ff2[9]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff1_reg[0] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(tol_in[0]),
        .Q(tol_ff1[0]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff1_reg[10] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(tol_in[10]),
        .Q(tol_ff1[10]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff1_reg[11] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(tol_in[11]),
        .Q(tol_ff1[11]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff1_reg[12] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(tol_in[12]),
        .Q(tol_ff1[12]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff1_reg[13] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(tol_in[13]),
        .Q(tol_ff1[13]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff1_reg[14] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(tol_in[14]),
        .Q(tol_ff1[14]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff1_reg[15] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(tol_in[15]),
        .Q(tol_ff1[15]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff1_reg[1] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(tol_in[1]),
        .Q(tol_ff1[1]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff1_reg[2] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(tol_in[2]),
        .Q(tol_ff1[2]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff1_reg[3] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(tol_in[3]),
        .Q(tol_ff1[3]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff1_reg[4] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(tol_in[4]),
        .Q(tol_ff1[4]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff1_reg[5] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(tol_in[5]),
        .Q(tol_ff1[5]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff1_reg[6] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(tol_in[6]),
        .Q(tol_ff1[6]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff1_reg[7] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(tol_in[7]),
        .Q(tol_ff1[7]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff1_reg[8] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(tol_in[8]),
        .Q(tol_ff1[8]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff1_reg[9] 
       (.C(clk_in),
        .CE(data_valid_pulse_in),
        .D(tol_in[9]),
        .Q(tol_ff1[9]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff2_reg[0] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(tol_ff1[0]),
        .Q(tol_ff2[0]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff2_reg[10] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(tol_ff1[10]),
        .Q(tol_ff2[10]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff2_reg[11] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(tol_ff1[11]),
        .Q(tol_ff2[11]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff2_reg[12] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(tol_ff1[12]),
        .Q(tol_ff2[12]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff2_reg[13] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(tol_ff1[13]),
        .Q(tol_ff2[13]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff2_reg[14] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(tol_ff1[14]),
        .Q(tol_ff2[14]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff2_reg[15] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(tol_ff1[15]),
        .Q(tol_ff2[15]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff2_reg[1] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(tol_ff1[1]),
        .Q(tol_ff2[1]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff2_reg[2] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(tol_ff1[2]),
        .Q(tol_ff2[2]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff2_reg[3] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(tol_ff1[3]),
        .Q(tol_ff2[3]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff2_reg[4] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(tol_ff1[4]),
        .Q(tol_ff2[4]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff2_reg[5] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(tol_ff1[5]),
        .Q(tol_ff2[5]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff2_reg[6] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(tol_ff1[6]),
        .Q(tol_ff2[6]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff2_reg[7] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(tol_ff1[7]),
        .Q(tol_ff2[7]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff2_reg[8] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(tol_ff1[8]),
        .Q(tol_ff2[8]),
        .R(1'b0));
  FDRE #(
    .INIT(1'b0)) 
    \tol_ff2_reg[9] 
       (.C(clk_in),
        .CE(adc_done_pulse_in),
        .D(tol_ff1[9]),
        .Q(tol_ff2[9]),
        .R(1'b0));
endmodule
`ifndef GLBL
`define GLBL
`timescale  1 ps / 1 ps

module glbl ();

    parameter ROC_WIDTH = 100000;
    parameter TOC_WIDTH = 0;

//--------   STARTUP Globals --------------
    wire GSR;
    wire GTS;
    wire GWE;
    wire PRLD;
    tri1 p_up_tmp;
    tri (weak1, strong0) PLL_LOCKG = p_up_tmp;

    wire PROGB_GLBL;
    wire CCLKO_GLBL;
    wire FCSBO_GLBL;
    wire [3:0] DO_GLBL;
    wire [3:0] DI_GLBL;
   
    reg GSR_int;
    reg GTS_int;
    reg PRLD_int;

//--------   JTAG Globals --------------
    wire JTAG_TDO_GLBL;
    wire JTAG_TCK_GLBL;
    wire JTAG_TDI_GLBL;
    wire JTAG_TMS_GLBL;
    wire JTAG_TRST_GLBL;

    reg JTAG_CAPTURE_GLBL;
    reg JTAG_RESET_GLBL;
    reg JTAG_SHIFT_GLBL;
    reg JTAG_UPDATE_GLBL;
    reg JTAG_RUNTEST_GLBL;

    reg JTAG_SEL1_GLBL = 0;
    reg JTAG_SEL2_GLBL = 0 ;
    reg JTAG_SEL3_GLBL = 0;
    reg JTAG_SEL4_GLBL = 0;

    reg JTAG_USER_TDO1_GLBL = 1'bz;
    reg JTAG_USER_TDO2_GLBL = 1'bz;
    reg JTAG_USER_TDO3_GLBL = 1'bz;
    reg JTAG_USER_TDO4_GLBL = 1'bz;

    assign (strong1, weak0) GSR = GSR_int;
    assign (strong1, weak0) GTS = GTS_int;
    assign (weak1, weak0) PRLD = PRLD_int;

    initial begin
	GSR_int = 1'b1;
	PRLD_int = 1'b1;
	#(ROC_WIDTH)
	GSR_int = 1'b0;
	PRLD_int = 1'b0;
    end

    initial begin
	GTS_int = 1'b1;
	#(TOC_WIDTH)
	GTS_int = 1'b0;
    end

endmodule
`endif
